From 2b85a1279190a5689b9a11f48398795f6e0c0aa7 Mon Sep 17 00:00:00 2001
From: Jiri J <jirij.jabb@gmail.com>
Date: Tue, 6 Oct 2009 09:43:36 +0200
Subject: [PATCH] udhcpd: leases file config support

Signed-off-by: Jiri J <jirij.jabb@gmail.com>
---
 networking/udhcp/Config.in |   14 +++++++++++---
 networking/udhcp/dhcpd.h   |    5 +++++
 networking/udhcp/files.c   |    2 ++
 3 files changed, 18 insertions(+), 3 deletions(-)

diff --git a/networking/udhcp/Config.in b/networking/udhcp/Config.in
index 5f76dd8..88917bb 100644
--- a/networking/udhcp/Config.in
+++ b/networking/udhcp/Config.in
@@ -19,10 +19,18 @@ config APP_DHCPRELAY
 	  and forwards these requests to a different interface or dhcp
 	  server.
 
+config FEATURE_UDHCPD_LEASES_FILE
+	bool "Support for leases file"
+	default y
+	depends on APP_UDHCPD
+	help
+	  If selected, udhcpd will have support for reading and writing
+	  the leases file.
+
 config APP_DUMPLEASES
 	bool "Lease display utility (dumpleases)"
 	default n
-	depends on APP_UDHCPD
+	depends on APP_UDHCPD && FEATURE_UDHCPD_LEASES_FILE
 	help
 	  dumpleases displays the leases written out by the udhcpd server.
 	  Lease times are stored in the file by time remaining in lease, or
@@ -31,7 +39,7 @@ config APP_DUMPLEASES
 config FEATURE_UDHCPD_WRITE_LEASES_EARLY
 	bool "Rewrite the lease file at every new acknowledge"
 	default n
-	depends on APP_UDHCPD
+	depends on APP_UDHCPD && FEATURE_UDHCPD_LEASES_FILE
 	help
 	  If selected, udhcpd will write a new file with leases every
 	  time a new lease has been accepted, thus eliminating the need
@@ -41,7 +49,7 @@ config FEATURE_UDHCPD_WRITE_LEASES_EARLY
 config DHCPD_LEASES_FILE
 	string "Absolute path to lease file"
 	default "/var/lib/misc/udhcpd.leases"
-	depends on APP_UDHCPD
+	depends on APP_UDHCPD && FEATURE_UDHCPD_LEASES_FILE
 	help
 	  udhcpd stores addresses in a lease file. This is the absolute path
 	  of the file. Normally it is safe to leave it untouched.
diff --git a/networking/udhcp/dhcpd.h b/networking/udhcp/dhcpd.h
index 4f6b73e..8376abb 100644
--- a/networking/udhcp/dhcpd.h
+++ b/networking/udhcp/dhcpd.h
@@ -135,8 +135,13 @@ int send_inform(struct dhcp_packet *oldpacket) FAST_FUNC;
 /*** files.h ***/
 
 void read_config(const char *file) FAST_FUNC;
+#if ENABLE_FEATURE_UDHCPD_LEASES_FILE
 void write_leases(void) FAST_FUNC;
 void read_leases(const char *file) FAST_FUNC;
+#else
+# define write_leases() ((void)0)
+# define read_leases(file) ((void)0)
+#endif
 struct option_set *find_option(struct option_set *opt_list, uint8_t code) FAST_FUNC;
 
 
diff --git a/networking/udhcp/files.c b/networking/udhcp/files.c
index 1b2cc96..84e19a5 100644
--- a/networking/udhcp/files.c
+++ b/networking/udhcp/files.c
@@ -340,6 +340,7 @@ void FAST_FUNC read_config(const char *file)
 }
 
 
+#if ENABLE_FEATURE_UDHCPD_LEASES_FILE
 void FAST_FUNC write_leases(void)
 {
 	int fd;
@@ -437,3 +438,4 @@ void FAST_FUNC read_leases(const char *file)
  ret:
 	close(fd);
 }
+#endif
-- 
1.6.3.3

